# -*- coding: utf-8 -*-
import serial
import time

class SerialHID:
	ser=""
	def __init__(self,portNum):
		SerialHID.ser = serial.Serial(portNum, 9600)

	class Mouse:
		def click(self, button='MOUSE_LEFT'):
			if button == 'MOUSE_LEFT':
				msg = 'MCL'
			elif button == 'MOUSE_RIGHT':
				msg = 'MCR'
			elif button == 'MOUSE_MIDDLE':
				msg = 'MCM'
			else:
				return
			SerialHID.ser.write(bytes(msg, "utf-8"))
			time.sleep(0.5)
			
			
		def move(self, xVal, yVal, wheel=0):
			SerialHID.ser.write(bytes("MMV"+str(int(xVal))+":"+str(int(yVal))+":"+str(int(wheel))+":", "utf-8"))
			time.sleep(0.5)
			
			
		def press(self, button='MOUSE_LEFT'):
			if button == 'MOUSE_LEFT':
				msg = 'MPL'
			elif button == 'MOUSE_RIGHT':
				msg = 'MPR'
			elif button == 'MOUSE_MIDDLE':
				msg = 'MPM'
			else:
				return
			SerialHID.ser.write(bytes(msg, "utf-8"))
			
			
		def release(self, button='MOUSE_LEFT'):
			if button == 'MOUSE_LEFT':
				msg = 'MRL'
			elif button == 'MOUSE_RIGHT':
				msg = 'MRR'
			elif button == 'MOUSE_MIDDLE':
				msg = 'MRM'
			else:
				return
			SerialHID.ser.write(bytes(msg, "utf-8"))
			
			
		def isPressed(self, button='MOUSE_LEFT'):
			if button == 'MOUSE_LEFT':
				msg = 'MSL'
			elif button == 'MOUSE_RIGHT':
				msg = 'MSR'
			elif button == 'MOUSE_MIDDLE':
				msg = 'MSM'
			else:
				return
			SerialHID.ser.write(bytes(msg, "utf-8"))
			return int(SerialHID.ser.read(1))
				
				
	class Keyboard:
		KEY_LEFT_CTRL = 0x80
		KEY_LEFT_SHIFT = 0x81
		KEY_LEFT_ALT = 0x82
		KEY_LEFT_GUI = 0x83
		KEY_RIGHT_CTRL = 0x84
		KEY_RIGHT_SHIFT = 0x85
		KEY_RIGHT_ALT = 0x86
		KEY_RIGHT_GUI = 0x87
		KEY_UP_ARROW = 0xDA
		KEY_DOWN_ARROW = 0xD9
		KEY_LEFT_ARROW = 0xD8
		KEY_RIGHT_ARROW = 0xD7
		KEY_BACKSPACE = 0xB2
		KEY_TAB = 0xB3
		KEY_RETURN = 0xB0
		KEY_ESC = 0xB1
		KEY_INSERT = 0xD1
		KEY_DELETE = 0xD4
		KEY_PAGE_UP = 0xD3
		KEY_PAGE_DOWN = 0xD6
		KEY_HOME = 0xD2
		KEY_END = 0xD5
		KEY_CAPS_LOCK = 0xC1
		KEY_F1 = 0xC2
		KEY_F2 = 0xC3
		KEY_F3 = 0xC4
		KEY_F4 = 0xC5
		KEY_F5 = 0xC6
		KEY_F6 = 0xC7
		KEY_F7 = 0xC8
		KEY_F8 = 0xC9
		KEY_F9 = 0xCA
		KEY_F10 = 0xCB
		KEY_F11 = 0xCC
		KEY_F12 = 0xCD

		def press(self, key):
			if type(key) is str:
				SerialHID.ser.write(bytes("KPS"+key, "utf-8"))
			else:
				byteArray = bytes("KPS", "utf-8")+key.to_bytes((key.bit_length() + 7) // 8, byteorder='big')
				SerialHID.ser.write(byteArray)
			
			
		def print(self, printStr):
			ret = 0
			for key in printStr:
				if type(key) is str:
					SerialHID.ser.write(bytes("KPN"+key, "utf-8"))
				else:
					byteArray = bytes("KPN", "utf-8")+key.to_bytes((key.bit_length() + 7) // 8, byteorder='big')
					SerialHID.ser.write(byteArray)
				ret = ret + int(SerialHID.ser.read(1))
			return ret
				
				
		def println(self, printStr):
			ret = self.print(printStr+"\n\r")
			return ret
			
			
		def release(self, key):
			if type(key) is str:
				SerialHID.ser.write(bytes("KRL"+key, "utf-8"))
			else:
				byteArray = bytes("KRL", "utf-8")+key.to_bytes((key.bit_length() + 7) // 8, byteorder='big')
				SerialHID.ser.write(byteArray)
			return int(SerialHID.ser.read(1))
			
		def releaseAll(self):
			SerialHID.ser.write(bytes("KRA", "utf-8"))
			
		def write(self, printStr):
			ret=0
			for key in printStr:
				if type(key) is str:
					SerialHID.ser.write(bytes("KWR"+key, "utf-8"))
				else:
					byteArray = bytes("KWR", "utf-8")+key.to_bytes((key.bit_length() + 7) // 8, byteorder='big')
					SerialHID.ser.write(byteArray)
				ret = ret + int(SerialHID.ser.read(1))
			return ret
		